#include "stm32f10x.h"
#include "delay.h"    //delay.cdelay.hļʹãҪdelay.h
#include "display12864.h"

#define u16 unsigned short   //Ϊ˿ֲԺã STM 32 ѾıٶһΡ
#define u8 unsigned char

/********** Ŷ塣**************/

#define DisIO GPIOC                 //12864ҪʹõI/O˿ڡ
#define DisClk RCC_APB2Periph_GPIOC  //12864ҪʹõI/O˿ڵʱӡ
#define Data GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7
                                       //12864ʹõš
#define RS GPIO_Pin_9
#define RW GPIO_Pin_10
#define EN GPIO_Pin_11       //ʹܶʹõš
#define PSB GPIO_Pin_12      //岢ģʽѡ˿ʹõš

/*********************************************/
                					    
GPIO_InitTypeDef  GPIOStru;  //ڶΪı

void IOInitOut(void)           //ж˿ڳʼΪģʽĺ
{
    GPIOStru.GPIO_Mode = GPIO_Mode_Out_PP;//еΪıʼ
    GPIOStru.GPIO_Speed = GPIO_Speed_50MHz;
    GPIOStru.GPIO_Pin = Data|RS|RW|EN|PSB;

    RCC_APB2PeriphClockCmd(DisClk,ENABLE);
    GPIO_Init(DisIO,&GPIOStru);	
}

void IOInitIn(void)           //ųʼΪĺ
{
    GPIOStru.GPIO_Mode = GPIO_Mode_IN_FLOATING;//Ϊıʼ
    GPIOStru.GPIO_Speed = GPIO_Speed_50MHz;
    GPIOStru.GPIO_Pin = Data;

    RCC_APB2PeriphClockCmd(DisClk,ENABLE);   //ж˿ڳʼΪģʽĺ   
    GPIO_Init(DisIO,&GPIOStru);	
}

void WaitBusy(void)          //ȴ12864æ״̬ĺ
{
    IOInitIn();        //ŶΪ룻
    GPIO_ResetBits(DisIO,RS);  //RS = 0.
    GPIO_SetBits(DisIO,RW);    //RW = 1.
    GPIO_SetBits(DisIO,EN);    //EN = 1.
    while(GPIO_ReadInputData(DisIO) & 0x0080); //ֻҪλ7ֵλ7æ־λ
    GPIO_ResetBits(DisIO,EN);  //EN = 0;
    IOInitOut();      //ŶΪ
}

void WriteCmd(u8 cmd)    //д
{
  	WaitBusy(); 
    GPIO_ResetBits(DisIO,RS);  //RS = 0.
    GPIO_ResetBits(DisIO,RW);  //RW = 0. 
    GPIO_SetBits(DisIO,EN);    //EN = 1.
    DisIO->ODR=((DisIO->ODR & 0xff00)|cmd); //˴ֱֻӲĴ
                  //ﵽֻıݼĴODRĵ8λλ
                  //ĿġΪֻе8λţ
                  //λǿţܸı䡣
    delay_ms(2);
    GPIO_ResetBits(DisIO,EN);  //EN = 0;
    delay_ms(2); 	
}

void WriteData(u8 data)  //дݺ
{
	WaitBusy(); 
    GPIO_SetBits(DisIO,RS);  //RS = 1. 
    GPIO_ResetBits(DisIO,RW);  //RW = 0. 
    GPIO_SetBits(DisIO,EN);    //EN = 1.
    DisIO->ODR=((DisIO->ODR & 0xff00)|data);  //ͬϡ
    delay_ms(2);
    GPIO_ResetBits(DisIO,EN);  //EN = 0;
    delay_ms(2); 
}

void InitDis(void)   //ʼ 12864 Ҫõ STM 32 š
{
    IOInitOut(); 	
    delay_init();   //ʼʱ΢  
    GPIO_SetBits(DisIO,PSB);  //PSB=1Ϊģʽ
    delay_ms(2); 
    WriteCmd(0x30);  //ѡָͣ8λģʽ
    delay_ms(2);
    WriteCmd(0x0c);  //ʾ,α,.
    delay_ms(2); 
    WriteCmd(0x01);  //ʾ DDRAM ĵַ AC Ϊ 00H.
    delay_ms(2);
    WriteCmd(0x06);  //ãⲿдݺ,ַ AC Զ 1
    delay_ms(2);
    WriteCmd(0x80);  // DDRAM ַ AC Ϊ 0.
    delay_ms(2);	
}

void DisStr(u8 *s)    //ʾַĺ
{
    while(*s != '\0')
    {
        WriteData(*s);
        s++;
        delay_ms(2);
    }
}

void DisInt(long int num)  //ʾͱĺ,ʾ16λֻʾ
{
	u8 temp[17];
	u8 str[17];
	int i=0,j=0;
	while(num != 0)	  //ﲻnum%10 != 0num10
	                  //磬100ͻͲܽѭ塣
	{
		temp[i] = (num%10)+0x30;
		num/=10;
		i++;
	}
	i--;           //Ϊi˳ѭ֮ǰԼһΣʱ
	                //ָһ洢ֵԪصĺһλá
	while(i != -1)	 //Ϊi=0ʱtemp[0]ֵ
	{
		str[j] = temp[i];
		j++;
		i--;	
	}
	str[j]='\0';  //Ϊi˳ѭ֮ǰԼһΣʱ
	              //ָһ洢ֵԪصĺһλá
	DisStr(str);	
}

void DisFloat(float fnum) //ʾ4λСĸλ16λ
{
	long int num = fnum*10000;
	u8 temp[17];
	u8 str[17];
	int i=0,j=0;
	while(num != 0)	                  
	{
		temp[i] = (num%10)+0x30;
		num/=10;
		i++;
		if(i == 4)	 //4λС󣬼С㡣
		{
			temp[i] = '.';
			i++;
		}
	}
	i--;   
	while(i != -1)	
	{
		str[j] = temp[i];
		j++;
		i--;	
	}
	str[j]='\0';  
	DisStr(str);			
}

/*ǹ궨λһΪ꣬ڶΪ꣬ʼ11С
ֻ16ĿΪλƶ*/

void locate16(int row, int col) 
{
	switch(row)
	{
		case 1: WriteCmd(0x80+col-1); break;
		case 2: WriteCmd(0x90+col-1); break;
		case 3: WriteCmd(0x88+col-1); break;
		case 4: WriteCmd(0x98+col-1); break;
	}
}

/*궨λ*/

